--- Edge Of Reality

local function SonicModelExists()
    if SonicSD and file.Exists("models/weapons/c_sonicsd.mdl", "GAME") then
        return true
    end
    return false
end

local T = {
    Exterior = {
        Parts = {
            vortex = {
                model = "models/FuzzyLeo/EdgeOfRealityJodie/vortex.mdl",
                pos = Vector(0,0,50),
                ang = Angle(0,0,0),
                scale =10
            },
        },
    },
}

T.Versions = {
    randomize = false,
    allow_custom = true,
    randomize_custom = false,

    main = {
        id = "edgeofrealityjodie",
    },
    other = {
		{
			name = "Classic Doors",
            id = "edgeofrealityjodiecl",
		},
	}
}

T.EnableClassicDoors = false

T.Base = "base"
T.Name = "The Edge Of Reality"
T.ID = "edgeofrealityjodie"
T.Interior = {
    Model = "models/FuzzyLeo/EdgeOfRealityJodie/Floor.mdl",
    IdleSound = {
        {
            path = "FuzzyLeo/EdgeOfReality/BBC_TARDIS_Atmos_Loop.wav",
            volume = 1
        },
    },
    ScreensEnabled = false,
    Light = {
        color = Color(255, 87, 15),
        warncolor = Color(255, 15, 15),
        pos = Vector(0, 0, 100),
        brightness = 0.2,
        nopower = false
    },
    Lights = {
        {
            color = Color(255, 255, 255),
            warncolor = Color(255, 15, 15),
            pos = Vector(0, -453, 74),
            brightness = 0,
            nopower = false
        },
        {
            color = Color(255, 87, 15),
            warncolor = Color(255, 15, 15),
            pos = Vector(160, 100, 130),
            brightness = 0,
            nopower = false
        },
    },
    Lamps = {
        consolelamp = {
            color = Color(255, 87, 15),
            texture = "effects/flashlight/soft",
            fov = 100,
            distance = 540,
            brightness = 0,
            pos = Vector(0, 0, 180),
            ang = Angle(90, 0, 0),
            shadows = false,
            sprite = false,
            warn = {
                -- same list of options available
                sprite_brightness = 0,
                color = Color(255, 15, 15),
            },
            nopower = true,
			off = {
				enabled = true,
				fov = 60,
				distance = 540,
				brightness = 0.5,
			},
			off_warn = {
				enabled = true,
				fov = 60,
				distance = 540,
				brightness = 0.2,
			},
        },
        doorlamp = {
            color = Color(255, 255, 255),
            texture = "effects/flashlight/soft",
            fov = 75,
            distance = 350,
            brightness = 0.04,
            pos = Vector(0, -279, 97),
            ang = Angle(14, -90, 0),
            shadows = false,
            sprite = false,
            warn = {
                -- same list of options available
                sprite_brightness = 0,
                color = Color(255, 15, 15),
            },
            nopower = true,
			off = {
				enabled = true,
				brightness = 0.02,
			},
			off_warn = {
				enabled = true,
				brightness = 0.02,
			},
        },
    },
    Portal = {
        -- Generated by portals debug tool
        pos = Vector(0, -480.39, 51.33),
        ang = Angle(0, 90, 0),
		width = 56,
		height = 100,
		thickness = -3.40,
		inverted = false,
    },
    Fallback = {
        pos = Vector(0, -454, 10),
        ang = Angle(0, 230, 0)
    },
    Screens = {
        {
            pos = Vector(-7.8, -24.7, 54),
            ang = Angle(0, 0, 90),
            width = 256,
            height = 205.5,
            gui_rows = 2,
            power_off_black = true
        }
    },
    Scanners = {
        {
            mat = "models/fuzzyleo/edgeofreality/tardisscreen",
            width = 1024,
            height = 1024,
            ang = Angle(0,0,0),
            fov = 75,
        }
    },
    ExitDistance = 1000,
    Sounds={
        FlightLoop = "FuzzyLeo/EdgeOfReality/CoolyDude/coral_inflight.wav",
        Door={
			enabled=true,
			open="FuzzyLeo/EdgeOfReality/CoolyDude/eot_door_open.mp3",
			close="FuzzyLeo/EdgeOfReality/CoolyDude/eot_door_close_3.mp3",
            locked = "FuzzyLeo/EdgeOfReality/EORDoorLock.mp3"
		},
        Power={
			On="FuzzyLeo/EdgeOfReality/CoolyDude/coral_power_on_new.wav",
			Off="FuzzyLeo/EdgeOfReality/CoolyDude/coral_power_off_new.wav",
		},
	},
    Sequences = "kleiner_sequence",
    Parts = {
		door = {
            Model="models/FuzzyLeo/EdgeOfReality/ExteriorJodieDoors.mdl",
            posoffset=Vector(26.7, 0, -48),
        },
        --basic interior stuff
        eorjodie_domevoid            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),                         },
        eorjodie_console            =   {},
        eorjodie_consoledetail1            =   {},
        eorjodie_consoledetail2            =   {},
        eorjodie_rotor            =   {},
        eorjodie_interiorpb            =   {},
        eorjodie_interiorwalls            =   {},
        eorjodie_roundels            =   {},
        eorjodie_interiorwallfunnel            =   {},

        --pillars
        eorjodie_pillar1            =   {ang = Angle(0, 0, 0),},
        eorjodie_pillar2            =   {ang = Angle(0, 60, 0),},
        eorjodie_pillar3            =   {ang = Angle(0, 120, 0),},
        eorjodie_pillar4            =   {ang = Angle(0, 180, 0),},
        eorjodie_pillar5            =   {ang = Angle(0, -60, 0),},
        eorjodie_pillar6            =   {ang = Angle(0, -120, 0),},

        --animated controls
        eorjodie_switch1            =   {pos = Vector(0,0,0),                     ang = Angle(0, -90, 0),                         },
        eorjodie_switch2            =   {pos = Vector(0,0,0),                     ang = Angle(0, -90, 0),                         },
        eorjodie_biglever           =   {pos = Vector(0,0,0),                     ang = Angle(0, -90, 0),                         },
        eorjodie_biglever2           =   {pos = Vector(0,0,0),                     ang = Angle(0, 90, 0),                         },
        eorjodie_smalltardis           =   {pos = Vector(0.3,0,0),                     ang = Angle(0, -90, 0),                         },

        --static controls (they are invisible hitboxes)
        eorjodie_manualdestination            =   {pos = Vector(-15.5, -26, 99),},





    },
    Controls = {
        eorjodie_biglever        = "teleport_double",
        eotcoral_flight         = "flight",
        default_screen              = nil,
        eotcoral_screentoggle        = "toggle_screens",
        eotcoral_scanners       = "toggle_scanners",
        eotcoral_doorlock         = "doorlock",
        eotcoral_enginerelease       = "engine_release",
        eorjodie_switch1          = "door",
        eotcoral_power          = "power",
        eorjodie_manualdestination            = "destination",
        eotcoral_hads                = "hads",
        eotcoral_coords          = "coordinates",
        eotcoral_repair         = "repair",
        eotcoral_redecoration    = "redecorate",
        eotcoral_handbrake           = "handbrake",
        eotcoral_music          = "music",
        eotcoral_fastreturn            = "fastreturn",
        eotcoral_lockingmechanism            = "physlock",
        eotcoral_isomorphic          = "isomorphic",
        eotcoral_float               = "float",
        eotcoral_cloak         = "cloak",
        eotcoral_vortexflight    = "vortex_flight",
        default_dematcircuit        = nil,
        eotcoral_sonicdispenser      = "sonic_dispenser",
        default_sonic_inserted      = SonicModelExists() and "sonic_dispenser",
        eorjodie_console              = "thirdperson_careful",
        default_atomaccel           = "spin_toggle",
        default_directionalpointer  = "spin_switch",



    },
    IntDoorAnimationTime = 0.4,
    Tips = {},
    -- Interior.Tips are deprecated; should be deleted when the extensions update and
    -- replace with Interior.CustomTips, Interior.PartTips and Interior.TipSettings
    TipSettings = {
        view_range_min = 70,
        view_range_max = 90,
    },
    CustomTips = {
        --{ text = "Example", pos = Vector(0, 0, 0) },
    },
    PartTips = {

        eorjodie_switch1            =   {pos = Vector(2.49, -38.596, 85.204), down = true},
        eorjodie_biglever             =   {pos = Vector(24.742, 0.092, 98.845), down = true},
        eorjodie_manualdestination            =   {pos = Vector(-15.5, -26, 99), down = true},

    },
    LightOverride = {
        basebrightness = 0.0025 ,
        nopowerbrightness = 0
    },

    BreakdownEffectPos = Vector(0, 0, 40),
}

T.Interior.TextureSets = {
	["normal"] = {
		prefix = "models/FuzzyLeo/EdgeOfRealityJodie/",

                --Door Power
		        { "door", 0, "tardis" },
                { "door", 3, "tardis_white" },
				{ "door", 5, "tardis_alt1" },
				{ "door", 6, "tardis_alt2" },
				{ "door", 7, "tardis_alt3" },
				{ "door", 8, "tardis_alt4" },

                --Door Frame Power
                { "eorjodie_interiorpb", 0, "tardis" },
                { "eorjodie_interiorpb", 2, "tardis_white" },
                { "eorjodie_interiorpb", 4, "tardis_alt1" },
				{ "eorjodie_interiorpb", 5, "tardis_alt2" },
				{ "eorjodie_interiorpb", 6, "tardis_alt3" },
				{ "eorjodie_interiorpb", 7, "tardis_alt4" },

                -- Interior Power
                { "eorjodie_rotor", 0, "M_Tardis_Crystal_Centre" },
                { "eorjodie_console", 1, "M_Tardis_Table_02" },

                { "eorjodie_roundels", 2, "M_Tardis_Crystal_Floor" },
                { "eorjodie_roundels", 0, "M_Tardis_Hexagon_Lights_01" },

                { "self", 2, "M_Tardis_Floor_02" },
                { "self", 3, "M_Tardis_Floor_03" },
                { "self", 4, "M_Tardis_Floor_04" },

                --Pillars
                { "eorjodie_pillar1", 0, "M_Tardis_Crystal_Shard_Bottom" },
                { "eorjodie_pillar1", 1, "M_Tardis_Crystal_Shard_centre" },

                { "eorjodie_claw1", 0, "M_Tardis_Crystal_Shard_top" },
                { "eorjodie_pillarstatictop1", 0, "M_Tardis_Crystal_Shard_top" },
                { "eorjodie_altclaw1", 0, "M_Tardis_Crystal_Shard_top" },



                { "eorjodie_pillar2", 0, "M_Tardis_Crystal_Shard_Bottom" },
                { "eorjodie_pillar2", 1, "M_Tardis_Crystal_Shard_centre" },

                { "eorjodie_claw2", 0, "M_Tardis_Crystal_Shard_top" },
                { "eorjodie_pillarstatictop2", 0, "M_Tardis_Crystal_Shard_top" },
                { "eorjodie_altclaw2", 0, "M_Tardis_Crystal_Shard_top" },



                { "eorjodie_pillar3", 0, "M_Tardis_Crystal_Shard_Bottom" },
                { "eorjodie_pillar3", 1, "M_Tardis_Crystal_Shard_centre" },

                { "eorjodie_claw3", 0, "M_Tardis_Crystal_Shard_top" },
                { "eorjodie_pillarstatictop3", 0, "M_Tardis_Crystal_Shard_top" },
                { "eorjodie_altclaw3", 0, "M_Tardis_Crystal_Shard_top" },



                { "eorjodie_pillar4", 0, "M_Tardis_Crystal_Shard_Bottom" },
                { "eorjodie_pillar4", 1, "M_Tardis_Crystal_Shard_centre" },

                { "eorjodie_claw4", 0, "M_Tardis_Crystal_Shard_top" },
                { "eorjodie_pillarstatictop4", 0, "M_Tardis_Crystal_Shard_top" },
                { "eorjodie_altclaw4", 0, "M_Tardis_Crystal_Shard_top" },



                { "eorjodie_pillar5", 0, "M_Tardis_Crystal_Shard_Bottom" },
                { "eorjodie_pillar5", 1, "M_Tardis_Crystal_Shard_centre" },

                { "eorjodie_claw5", 0, "M_Tardis_Crystal_Shard_top" },
                { "eorjodie_pillarstatictop5", 0, "M_Tardis_Crystal_Shard_top" },
                { "eorjodie_altclaw5", 0, "M_Tardis_Crystal_Shard_top" },



                { "eorjodie_pillar6", 0, "M_Tardis_Crystal_Shard_Bottom" },
                { "eorjodie_pillar6", 1, "M_Tardis_Crystal_Shard_centre" },

                { "eorjodie_claw6", 0, "M_Tardis_Crystal_Shard_top" },
                { "eorjodie_pillarstatictop6", 0, "M_Tardis_Crystal_Shard_top" },
                { "eorjodie_altclaw6", 0, "M_Tardis_Crystal_Shard_top" },



			},
    ["flight"] = {
		prefix = "models/FuzzyLeo/EdgeOfRealityJodie/",
        base = "normal",
	},
    ["warning_flight"] = {
		prefix = "models/FuzzyLeo/EdgeOfRealityJodie/warning/",
        base = "normal",
	},
    ["poweroff"] = {
                prefix = "models/FuzzyLeo/EdgeOfRealityJodie/off/",
                base = "normal",
    },
	["warning"] = {
		prefix = "models/FuzzyLeo/EdgeOfRealityJodie/warning/",
        base = "normal",
	},
}


T.CustomHooks = {
	travel_textures = {
        exthooks = {
            ["PostInitialize"] = true,
            ["PowerToggled"] = true,
            ["HealthWarningToggled"] = true,
            ["DematStart"] = true,
            ["MatStart"] = true,
            ["PreMatStart"] = true,
            ["StopDemat"] = true,
            ["StopMat"] = true,
            ["InterruptTeleport"] = true,
        },
        func = function(ext, int, data_id, data_value)
			local flight = ext:GetData("flight")
			local teleport = ext:GetData("teleport")
			local vortex = ext:GetData("vortex")
			local power = ext:GetData("power-state")
			local warning = ext:GetData("health-warning", false)
			local active = flight or teleport or vortex

			local selected = "normal"

			if not power then
				selected = "poweroff"
			elseif warning and active then
				selected = "warning_flight"
			elseif warning then
				selected = "warning"
			elseif active then
				selected = "flight"
			end

			int:ApplyTextureSet(selected)
            ext:ApplyTextureSet(selected)
		end
	},
    door_bodygroup_sync_ext = {
        exthooks = { ["PartBodygroupChanged"] = true, },
        inthooks = { ["PartBodygroupChanged"] = true, },
        func = function(ext,int,part,bodygroup,value)
            if not IsValid(int) then return end
            if not IsValid(part) or part.ID ~= "door" then return end

            local door_int = int:GetPart("door")
            local door_ext = ext:GetPart("door")

            if not IsValid(door_int) or not IsValid(door_ext) then return end

            if part.ExteriorPart and door_int:GetBodygroup(bodygroup) ~= value then
                door_int:SetBodygroup(bodygroup, value)
            end

            if part.InteriorPart and door_ext:GetBodygroup(bodygroup) ~= value then
                door_ext:SetBodygroup(bodygroup, value)
            end

        end,
    },
}


T.CustomSettings = {
    interior_claw = {
        text = "Claw Movement",
        value_type = "list",
        value = "eordefaultclaw",
        options = {
            ["eordefaultclaw"] = "Default",
            ["eorfrozenclaw"] = "Static",
            ["eoraccurateclaw"] = "Series 11",
        }
    },
    interior_accuraterotor = {
        text = "Accurate Rotor Rotation",
        value_type = "bool",
        value = false,
    },
}

T.Templates = {

    --Exterior
    edgeoftime_box = { override = true, },


    --Customisable Stuff
    eorjodie_defaultclaw = {
		override = true,
        condition = function(id, ply, ent)
            local setting_val = TARDIS:GetCustomSetting(id, "interior_claw", ply)
            return (setting_val == "eordefaultclaw")
        end,
	},
    eorjodie_frozenclaw = {
		override = true,
        condition = function(id, ply, ent)
            local setting_val = TARDIS:GetCustomSetting(id, "interior_claw", ply)
            return (setting_val == "eorfrozenclaw")
        end,
	},
    eorjodie_accurateclaw = {
        override = true,
        condition = function(id, ply, ent)
            local setting_val = TARDIS:GetCustomSetting(id, "interior_claw", ply)
            return (setting_val == "eoraccurateclaw")
        end,
    },
    eorjodie_accuraterotor = {
        override = true,
        condition = function(id, ply, ent)
            return TARDIS:GetCustomSetting(id, "interior_accuraterotor", ply)
        end,
    },
}

TARDIS:AddInterior(T)
